// D3DXApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "D3DXApp.h"

#include "MainFrm.h"
#include "GFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

float gspeed = 1.5; // koeficinet rychlosti hry
int   gmaxmrchovnik = 0;
bool  gdeadmatch_bombkill = true; // zda se po urcite dobe ukoncuje dedmatch nasilne
bool  gexplode_predict_visible = true; // zda je viditelna predikce exploze
int   glangfile = 0;                   // ID jmena souboru s jazykem
bool  gsoundavailable = true;;


HDSoundBuffer g_sb[25];


/////////////////////////////////////////////////////////////////////////////
// CD3DXAppApp

BEGIN_MESSAGE_MAP(CD3DXAppApp, CWinApp)
	//{{AFX_MSG_MAP(CD3DXAppApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD3DXAppApp construction

#define INI_FILE "bomber.set"

CD3DXAppApp::CD3DXAppApp()
{
	srand( (unsigned)time( NULL ) );

	CFile file;
	if (file.Open(INI_FILE, CFile::modeRead|CFile::typeBinary)) {
		file.Read(&gspeed, sizeof(float));
		file.Read(&gmaxmrchovnik, sizeof(int));
		file.Read(&gdeadmatch_bombkill, sizeof(bool));
		file.Read(&gexplode_predict_visible, sizeof(bool));
		file.Read(&glangfile, sizeof(int));
		file.Read(&m_fullscreen, sizeof(bool));
		file.Read(&gsoundavailable, sizeof(bool));
		file.Close();
	}
}

CD3DXAppApp::~CD3DXAppApp()
{
	CFile file;
	if (file.Open(INI_FILE, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary)) {
		file.Write(&gspeed, sizeof(float));
		file.Write(&gmaxmrchovnik, sizeof(int));
		file.Write(&gdeadmatch_bombkill, sizeof(bool));
		file.Write(&gexplode_predict_visible, sizeof(bool));
		file.Write(&glangfile, sizeof(int));
		file.Write(&m_fullscreen, sizeof(bool));
		file.Write(&gsoundavailable, sizeof(bool));
		file.Close();
	}
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CD3DXAppApp object

CD3DXAppApp theApp;
HD3DX d3dx;

/////////////////////////////////////////////////////////////////////////////
// CD3DXAppApp initialization

BOOL CD3DXAppApp::InitInstance()
{

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if((gfx_module = LoadLibrary("data\\gfx.dll")) == NULL) {
		AfxMessageBox("ERROR - GFX.DLL");
		return FALSE;
	}

	GFile::LoadData();

	lng.LoadLanguage(glangfile);

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Hippo Games"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);




	// The one and only window has been initialized, so show and update it.
	pFrame->OnInit(0,0);
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CD3DXAppApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CD3DXAppApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CD3DXAppApp message handlers
#ifdef _DEBUG
bool CD3DXAppApp::m_fullscreen = false;
#else
bool CD3DXAppApp::m_fullscreen = true;
#endif


void CD3DXAppApp::InitDirectX()
{	
	if (!d3dx.Create(800, 600, 32, !m_fullscreen)) {
		if (!d3dx.Create(800, 600, 32, m_fullscreen)) {
			AfxMessageBox("Direct 3D");
			exit(1);
		}
		m_fullscreen = !m_fullscreen;
	}

	if (!dsound.Create()) {
		AfxMessageBox("Direct Sound");
		exit(1);
	}

	if (!dinput.Create()) {
		AfxMessageBox("Direct Input");
		exit(1);
	}
/*
	#define SND_MENU_CHNG         0 
	#define SND_MENU_SEL          1
	#define SND_GAME_EXPLODE      2
	#define SND_GAME_MEGA_EXPLODE 3
	#define SND_GAME_BOMBPUT      4
	#define SND_GAME_BONUS        5
	#define SND_GAME_TIME_BONUS   6
	#define SND_GAME_DEAD_BOMBER  7
	napalmbomba   8
	9 - psani na stroji
*/

	g_sb[0].LoadFromRes("MENU1");
	g_sb[1].LoadFromRes("MENU2");
	g_sb[SND_GAME_EXPLODE].LoadFromRes("EXPLODE");
	g_sb[SND_GAME_MEGA_EXPLODE].LoadFromRes("MEGAEXPLODE");
	g_sb[4].LoadFromRes("PUT_BOMB");
	g_sb[SND_GAME_BONUS].LoadFromRes("BONUS");
	g_sb[SND_GAME_TIME_BONUS].LoadFromRes("TIME_BONUS");
	g_sb[7].LoadFromRes("SMRT");
	g_sb[8].LoadFromRes("NAPALM");
	g_sb[9].LoadFromRes("B3");

	// mrchy
	g_sb[10].LoadFromRes("SMRT_KOULE");
	g_sb[11].LoadFromRes("SMRT_SLIZKA");
	g_sb[12].LoadFromRes("SMRT_MESIC");
	g_sb[13].LoadFromRes("SMRT_MESIC");
	g_sb[14].LoadFromRes("MEGAEXPLODE"); // televize
//	g_sb[15].LoadFromRes("SMRT_KOULE"); // TV blesk
	g_sb[16].LoadFromRes("NAPALM");  // koule ostnata
	g_sb[17].LoadFromRes("SMRT_MESIC"); // duch
	g_sb[18].LoadFromRes("SMRT_KOULE");
	g_sb[19].LoadFromRes("SMRT_SLIZKA");
	g_sb[20].LoadFromRes("SMRT_DUDLIK");
//	g_sb[21].LoadFromRes("SMRT_MESIC"); - sen
//	g_sb[22].LoadFromRes("SMRT_MESIC");
//	g_sb[23].LoadFromRes("SMRT_MESIC");
	g_sb[24].LoadFromRes("NAPALM"); // cervenokulka

/*
	if (!hmp3.Create()) {
		AfxMessageBox("Direct Show Audio");
		exit(1);
	}

*/
//	hmp3.Play("test.mp3", true);
}
