// GFile.cpp: implementation of the GFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "GFile.h"
#include "data.h"
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


st_zed P_zed[MAX_ZED] = {
	{"zem",                  0, 0, true,  0, 1, 0, 1, false},
	{"strana leva",          1, 0, false, 0, 1, 0, 1, false},
	{"strana leva-horni",    2, 0, false, 0, 1, 0, 1, false},
	{"strana horni",         3, 0, false, 0, 1, 0, 1, false},
	{"strana prava-horni",   4, 0, false, 0, 1, 0, 1, false},
	{"strana prava",         5, 0, false, 0, 1, 0, 1, false},
	{"strana leva-doli",     6, 0, false, 0, 1, 0, 1, false},
	{"strana dolni",         7, 0, false, 0, 1, 0, 1, false},
	{"strana prava dolni",   8, 0, false, 0, 1, 0, 1, false},
	{"nepruchodna",          9, 0, false, 0, 1, 0, 1, false},
	{"nepruchodna s teckou", 0, 1, false, 3, 3, 0, 1, false},
	{"znicitelna",           4, 1, false, 0, 1, 5, 3, true},
};

st_mrcha P_mrcha[MAX_MRCH] = {
	{"Koule",          4, 4, 2, 1, 100, 50, 70, false, false, 255, 30},
	{"Slizoun",         2, 4, 3, 2, 100, 50, 70, false, false, 255, 30},
	{"Mracek",          4, 4, 2, 1, 100, 50, 70, false, false, 255, 30},
	{"Mesicek",         2, 4, 3, 2, 100, 50, 70, false, false, 255, 30},
};

st_bomber P_bomber = {4, 8, 2, 50, 70, 30};

#define DAT_FILE "bomber.dat"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GFile::GFile()
{

}

GFile::~GFile()
{

}

void GFile::LoadData()
{
	CFile file;
	if (!file.Open(DAT_FILE, CFile::modeRead|CFile::typeBinary)) {
		AfxMessageBox("Nepodarilo se nacist data hry!");
		exit(1);
	}
	file.Read(&P_bomber, sizeof(st_bomber));
	file.Read(&P_mrcha[0], sizeof(st_mrcha) * MAX_MRCH);
	file.Read(&P_zed[0], sizeof(st_zed) * MAX_ZED);
	
	file.Close();
}

void GFile::SaveData()
{
	CFile file;
	if (!file.Open(DAT_FILE, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary)) {
		AfxMessageBox("Nepodarilo se ulozit data hry!");
		return;
	}
	file.Write(&P_bomber, sizeof(st_bomber));
	file.Write(&P_mrcha[0], sizeof(st_mrcha) * MAX_MRCH);
	file.Write(&P_zed[0], sizeof(st_zed) * MAX_ZED);
	file.Close();
}

void GFile::SaveMap(st_map *map, const CString name)
{
	CString s;
	s = name;
	CFile file;
	if (!file.Open(name, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary)) {
		AfxMessageBox("Nepodarilo se ulozit data hry!");
		return;
	}
	file.Write(map, sizeof(st_map));
	file.Close();
}

void GFile::LoadMap(st_map *map, const CString file)
{
	CFile f;
	CString s = file;
	s = "maps\\" + s;
	if (!f.Open(file, CFile::modeRead|CFile::typeBinary)) 
		if (!f.Open(s, CFile::modeRead|CFile::typeBinary)) {
			AfxMessageBox("Nepodarilo se nacist mapu");
			return;
		}
	f.Read(map, sizeof(st_map));
	f.Close();
}
