/*  Hippo Games - 2000 (C) - http://www.prog.cz/hippo/
 *    __________________________________________________
 *   /\     __  __    _____   ______   ______   ______  \
 *   \ \   /\ \|\ \  /\_  _\ /\  __ \ /\  __ \ /\  __ \  \
 *    \ \  \ \ \_\ \ \//\ \/ \ \ \_\ \\ \ \_\ \\ \ \ \ \  \
 *     \ \  \ \  __ \  \ \ \  \ \  __/ \ \  __/ \ \ \ \ \  \
 *      \ \  \ \ \/\ \  \_\ \_ \ \ \/   \ \ \/   \ \ \_\ \  \
 *       \ \  \ \_\ \_\ /\____\ \ \_\    \ \_\    \ \_____\  \
 *        \ \  \/_/\/_/ \/____/  \/_/     \/_/     \/_____/   \
 *         \ \_________________________________________________\
 *          \/_________________________________________________/
 *                           
 *  
 *  Sub     : Funkce pro DirectInput
 *
 *  File    : HDInput.h
 *  
 *  Projekt : HDXII
 *  
 *  Autor   : Bernard Lidicky [berny@prog.cz]
 *
 *  Datum   : 29.12.2000
 *
 */      

#ifndef HDINPUT_HEADER
#define HDINPUT_HEADER

#define DIRECTINPUT_HEADER_VERSION  0x0800

#include <dinput.h>
#pragma comment (lib,"dinput8.lib")
#pragma comment (lib,"dxguid.lib")

class HDInput  
{
public:

	operator LPDIRECTINPUT8();


	void Update();
	bool Create(HINSTANCE hinst = NULL, HWND hwnd = NULL);
	HDInput();
	virtual ~HDInput();

	int m_x;
	int m_y;
	int m_z;
	int m_b[4];

	byte m_key[256];

private:
	LPDIRECTINPUT8        m_lpDI;
	LPDIRECTINPUTDEVICE8  m_lpKey;
	LPDIRECTINPUTDEVICE8  m_lpMouse;
};

extern HDInput dinput;

#endif // ifndef HDINPUT_HEADER
