// MSetting.cpp: implementation of the MSetting class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MSetting.h"
#include "D3DXApp.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern	float gspeed; // koeficinet rychlosti hry
extern	bool  gdeadmatch_bombkill; // zda se po urcite dobe ukoncuje dedmatch nasilne
extern	bool  gexplode_predict_visible; // zda je viditelna predikce exploze
extern   int   glangfile;                   // ID jmena souboru s jazykem
extern   bool gsoundavailable;


MSetting::MSetting()
{

}

MSetting::~MSetting()
{

}

void MSetting::Destroy()
{
	if (m_bPozadi != -1) d3dx.DestroyTexture(m_bPozadi);
	m_bPozadi = -1;
}

void MSetting::Draw()
{
	d3dx.Draw(m_bPozadi, 400, 300, 0, 1.5625);
	int col;

	if (m_sel == 0) m_font->DrawTextScaled( 400, 180,  0.9f, 1, 1, 0xffffffff, lng.Translate(30), D3DFONT_FILTERED | D3DFONT_CENTERED);
	else m_font->DrawTextScaled( 400, 180,  0.9f, 1, 1, 0xffaaaaaa, lng.Translate(30), D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 1) col = 0xffffffff;
	else col = 0xffaaaaaa; 
	if (gdeadmatch_bombkill) m_font->DrawTextScaled( 400, 220,  0.9f, 1, 1, col, lng.Translate(31), D3DFONT_FILTERED | D3DFONT_CENTERED);
	else 	m_font->DrawTextScaled( 400, 220,  0.9f, 1, 1, col, lng.Translate(32), D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 2) col = 0xffffffff;
	else col = 0xffaaaaaa; 
	if (gexplode_predict_visible) m_font->DrawTextScaled( 400, 260,  0.9f, 1, 1, col, lng.Translate(33), D3DFONT_FILTERED | D3DFONT_CENTERED);
	else 	m_font->DrawTextScaled( 400, 260,  0.9f, 1, 1, col, lng.Translate(34), D3DFONT_FILTERED | D3DFONT_CENTERED);

	CString s;
	s.Format("%s : %.1f", lng.Translate(35), gspeed);
	if (m_sel == 3) m_font->DrawTextScaled( 400, 300,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else m_font->DrawTextScaled( 400, 300,  0.9f, 1, 1, 0xffaaaaaa, s, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (CD3DXAppApp::m_fullscreen) s = lng.Translate(38);
	else s = lng.Translate(37);
	if (m_sel == 4) m_font->DrawTextScaled( 400, 340,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else m_font->DrawTextScaled( 400, 340,  0.9f, 1, 1, 0xffaaaaaa, s, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (gsoundavailable) s = lng.Translate(42);
	else s = lng.Translate(43);
	if (m_sel == 5) m_font->DrawTextScaled( 400, 380,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else m_font->DrawTextScaled( 400, 380,  0.9f, 1, 1, 0xffaaaaaa, s, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 6) m_font->DrawTextScaled( 400, 420,  0.9f, 1, 1, 0xffffffff, lng.Translate(36), D3DFONT_FILTERED | D3DFONT_CENTERED);
	else m_font->DrawTextScaled( 400, 420,  0.9f, 1, 1, 0xffaaaaaa, lng.Translate(36), D3DFONT_FILTERED | D3DFONT_CENTERED);
}

void MSetting::Init(CMainFrame *parent)
{
	GBase::Init(parent);

	m_sel = 0;

	m_bPozadi = d3dx.CreateTextureFromFile("data\\msetting.jpg");
}

int MSetting::OnKey(int nChar)
{
	switch (nChar) {
	case VK_DOWN   : if (++m_sel > MAX_SETTING_SEL-1) m_sel = 0; g_sb[0].Play();  break;
	case VK_UP     : if (--m_sel < 0) m_sel = MAX_SETTING_SEL-1; g_sb[0].Play();  break;
	case VK_RETURN : 
	case VK_SPACE  :
		g_sb[0].Play();
		switch (m_sel) {
		case 0 :
			if (++glangfile >= lng.m_langs) glangfile = 0;
			lng.LoadLanguage(glangfile);
			break;
		case 1:
			gdeadmatch_bombkill = !gdeadmatch_bombkill;
			break;
		case 2: 
			gexplode_predict_visible = !gexplode_predict_visible;
			break;
		case 3:
			if ( (gspeed += 0.1f) > 4) gspeed = 1;
			break;
		case 4:
			CD3DXAppApp::m_fullscreen = !CD3DXAppApp::m_fullscreen;
			m_font->InvalidateDeviceObjects();
			m_fontL->InvalidateDeviceObjects();
			m_font->DeleteDeviceObjects();
			m_fontL->DeleteDeviceObjects();
			d3dx.Resize(d3dx.m_w, d3dx.m_h, !CD3DXAppApp::m_fullscreen);
			m_font->InitDeviceObjects(d3dx.m_dev);
			m_fontL->InitDeviceObjects(d3dx.m_dev);
			break;
		case 5: 
			gsoundavailable = !gsoundavailable;
			break;
		case 6:
			return MENU_MAIN; 
			break;
		}
		break;
	case VK_RIGHT :
		switch (m_sel) {
		case 0 :
			if (++glangfile >= lng.m_langs) glangfile = 0;
			lng.LoadLanguage(glangfile);
			g_sb[0].Play();
			break;
		case 1:
			gdeadmatch_bombkill = !gdeadmatch_bombkill;
			g_sb[0].Play();
			break;
		case 2: 
			gexplode_predict_visible = !gexplode_predict_visible;
			g_sb[0].Play();
			break;
		case 3:
			if ( (gspeed += 0.1f) > 4) gspeed = 1;
			g_sb[0].Play();
			break;
		case 5: 
			gsoundavailable = !gsoundavailable;
			g_sb[0].Play();
			break;
		}
		break;
	case VK_LEFT :
		switch (m_sel) {
		case 0 :
			if (--glangfile < 0) glangfile = lng.m_langs-1;
			lng.LoadLanguage(glangfile);
			g_sb[0].Play();
			break;
		case 1:
			gdeadmatch_bombkill = !gdeadmatch_bombkill;
			g_sb[0].Play();
			break;
		case 2: 
			gexplode_predict_visible = !gexplode_predict_visible;
			g_sb[0].Play();
			break;
		case 3:
			if ( (gspeed -= 0.1f) < 1) gspeed = 4;
			g_sb[0].Play();
			break;
		case 5: 
			gsoundavailable = !gsoundavailable;
			g_sb[0].Play();
			break;
		}
		break;
	case 27 : 
		return MENU_MAIN; 
		break;
	}

	return MENU_DEFAULT;
}
