// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "D3DXApp.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_ERASEBKGND()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_WM_SETCURSOR()
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,  OnInit)
	ON_MESSAGE(WM_GRAPHNOTIFY, OnGraphEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_tmr = 0;
	m_actual = NULL;

	m_font  = new CD3DFont("Arial Black", 16, 0);
	m_fontL = new CD3DFont("Arial", 16, 0);

}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


BOOL CMainFrame::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

void CMainFrame::OnInit(int parama, int paramb)
{
	SetWindowText("Bombic");
//	ModifyStyle(WS_SIZEBOX | WS_MAXIMIZEBOX, 0, SWP_DRAWFRAME );
	m_cursor = AfxGetApp()->LoadCursor(IDC_CURSOR);

#ifndef _DEBUG
#ifndef _BETA
	intro.Create();
	intro.OpenClip("test.avi");
	intro.Play(false);
	if (CD3DXAppApp::m_fullscreen)
		intro.ToggleFullScreen();
#endif
#else
	InitGame();
#endif

#ifdef _BETA
	InitGame();
#endif

}

void CMainFrame::OnClose() 
{
	intro.CloseClip();
	m_font->DeleteDeviceObjects();
	m_fontL->DeleteDeviceObjects();
	d3dx.Destroy();
	
	if (m_font)	delete m_font;
	if (m_fontL)	delete m_fontL;


	CFrameWnd::OnClose();
}

BOOL CMainFrame::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
//	SetCursor(m_cursor);
	SetCursor(NULL);
	return TRUE;
}

void CMainFrame::OnKillFocus(CWnd* pNewWnd) 
{
	CFrameWnd::OnKillFocus(pNewWnd);
//	hmp3.KillFocus();
}

void CMainFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CFrameWnd::OnSetFocus(pOldWnd);
//	hmp3.SetFocus();
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{

	if (IsIconic() == FALSE) {

		if (GetForegroundWindow() == this)
			Move();

		if (GetForegroundWindow() == this || CD3DXAppApp::m_fullscreen == false)
			Draw();

		if (m_tmr) m_tmr++;

	}

	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::Move()
{
	if (m_actual) m_actual->Move();

}

void CMainFrame::Draw()
{
	if (d3dx.m_valid == false || d3dx.m_dev == NULL) return;

	if (d3dx.NeedRestore()) {

		SetWindowPos(NULL, 0, 0, 10, 10, SWP_NOMOVE  | SWP_NOZORDER  );

		m_font->InvalidateDeviceObjects();
		m_fontL->InvalidateDeviceObjects();
		m_font->DeleteDeviceObjects();
		m_fontL->DeleteDeviceObjects();
//		delete m_font;
//		delete m_fontL;

		d3dx.Restore();


//		m_font  = new CD3DFont("Arial Black", 16, 0);
//		m_fontL = new CD3DFont("Arial", 16, 0);
		m_font->InitDeviceObjects(d3dx.m_dev);
		m_fontL->InitDeviceObjects(d3dx.m_dev);

		return;
	}

	m_font->RestoreDeviceObjects();
	m_fontL->RestoreDeviceObjects();
	d3dx.BeginScene();

	if (m_actual) m_actual->Draw();


//	m_font->DrawTextScaled( 400, 50,  0.9f, 1.0f, 1.0f, 0xffffffff, "Beta 030", D3DFONT_FILTERED | D3DFONT_CENTERED);

	d3dx.EndScene();
	m_font->InvalidateDeviceObjects();
	m_fontL->InvalidateDeviceObjects();
/*

    D3DGAMMARAMP ddgr;
    WORD dwGamma;

    ZeroMemory( &ddgr, sizeof(ddgr) );


    dwGamma = 0;

    for( int iColor = 0; iColor < 256; iColor++ )
    {
        ddgr.red[iColor]   = dwGamma;
        ddgr.green[iColor] = dwGamma;
        ddgr.blue[iColor]  = dwGamma;

        dwGamma += (WORD) 128;
    }

//    d3dx.m_dev->SetGammaRamp( D3DSGR_NO_CALIBRATION , &ddgr );
    d3dx.m_dev->SetGammaRamp( D3DSGR_CALIBRATE , &ddgr );
	*/  
}

void CMainFrame::OnGraphEvent(int para, int parb)
{
	HDShow *hds = (HDShow *)parb;
	if (hds->HandleEvents()) {
		InitGame();
	}
}



void CMainFrame::InitGame()
{
	CD3DXAppApp::InitDirectX();
	m_font->InitDeviceObjects(d3dx.m_dev);
	m_fontL->InitDeviceObjects(d3dx.m_dev);

	StartIntro();
/*
	m_sb.LoadFromRes("TEST", AfxGetApp()->m_hInstance);
	m_sb.Play(true);

	m_sb.SetPan(10000);
	m_sb.SetFreq(DSBFREQUENCY_ORIGINAL);
	m_sb.SetVolume(0);

*/

	SetTimer(0, 25, NULL);

	m_tmr = 1;
}

void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);

	if (m_tmr == 0)  {
		intro.Stop();
		InitGame();
		return;
	}
	else 
		if (m_actual) {
			m_actual->OnKey(nChar);
		}
}

void CMainFrame::StartGame(CString file, int players, bool deadmatch, bool monsters, int bonuslevel)
{
	if (m_actual != NULL) m_actual->Destroy();
	d3dx.DestroyTextures();
	m_game.Init(this);
	m_game.LoadMap(file, players, deadmatch, monsters, bonuslevel);
	m_actual = &m_game;
}

void CMainFrame::StartMenu()
{
	if (m_actual != NULL) m_actual->Destroy();
	d3dx.DestroyTextures();
	m_menu.Init(this);
	m_actual = &m_menu;
}

void CMainFrame::StartIntro()
{
	if (m_actual != NULL) m_actual->Destroy();
	m_game.Destroy();
	d3dx.DestroyTextures();
	m_intro.Init(this);
	m_actual = &m_intro;
}
